#ifndef bqt_charmap_hh
#define bqt_charmap_hh

class charmap
{
public:
    class const_iterator
    {
        friend class charmap;
        bool valid;
        void set(unsigned a, unsigned b) { valid=true; first=a; second=b; }
    public:
        unsigned first, second;
        const_iterator() : valid(false) { }
        inline const const_iterator *operator ->() const { return this; }
        inline bool operator== (const const_iterator &b) const { return valid == b.valid; }
        inline bool operator!= (const const_iterator &b) const { return valid != b.valid; }
    };
    
	charmap();
    virtual ~charmap();
    
    const const_iterator end() const { return const_iterator(); }
    const const_iterator find(unsigned what) const;
    
    virtual const unsigned size() const = 0;
    virtual const unsigned short getkey(unsigned n) const = 0;
    virtual const unsigned short getvalue(unsigned n) const = 0;
};

#endif
