#ifndef bqt_charsets_hh
#define bqt_charsets_hh

#include <string>
#include <cwchar>

using namespace std;

#define wstring widecharstring 
typedef basic_string<wchar_t> wstring;

//class wstring : public basic_string<wchar_t>
//{
//};

class converter
{
    class charset *in;
    class charset *out;
public:
    converter(const string &inputmime, const string &outputmime);
    void setinputtype(const string &mime);
    void setmodifytype(const string &mime);
    ~converter();
    
    const wstring html2wstring(const string &s);
    const string wide2str(const wstring &s);
};

#include "charmap.hh"

extern const wchar_t FindEntity(const string &s);    
extern const char *RevFindEntity(const wchar_t ch);
extern wstring TryParseEntities(const string &s, unsigned &a);

class charset
{
public:
    virtual const wstring c2uni(const string &s, bool html=false) = 0;
    virtual const string uni2c(const wstring &s) = 0;
    virtual ~charset() { }
};

extern charset *newconverter(const string &csetname);

#endif
