#ifndef bqt_parse_hh
#define bqt_parse_hh

#include <map>
#include <list>
#include "charsets.hh"

using namespace std;

class Elem
{
public:
    bool set; /* true=set, false=clear */
    string tagname;
    map<string, wstring> parms;
public:
    Elem() : set(true)
    {
    }
};

class Eater
{
public:
    virtual bool comment(const string &s);    /* true = sytiin */
    virtual bool add(const wstring &s);
    virtual bool add(const Elem &e);
};

class Body
{
    converter &conv;
    list<Eater *> eaters; /* stack! */
public:
    Body(converter &c) : conv(c) { }
    void comment(const string &s);
    void add(const wstring &s);
    void add(const Elem &e);
};

class Page
{
    converter conv;
    Body body;
public:
    Page(const string &inputmime, const string &outputmime) : conv(inputmime, outputmime), body(conv)
    {
    }
    void Parse(const string &s);
};

#endif
